/* Copyright (C) 2004 - 2005  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
package com.db4o.test;

import java.io.*;

import com.db4o.*;

public class ServerRevokeAccess {
	
	static final String FILE = "ServerRevokeAccessTest.yap";
	
	public void test(){
		
		if(! Test.isClientServer() && Test.currentRunner.CLIENT_SERVER){
			
			try{
				new File(FILE).delete();
				ObjectServer server = Db4o.openServer(FILE, AllTests.SERVER_PORT);
			
				String user = "hohohi";
				String password = "hohoho";
				server.grantAccess(user, password);
			
				ObjectContainer con = Db4o.openClient(AllTests.SERVER_HOSTNAME, AllTests.SERVER_PORT, user,password);
				Test.ensure(con != null);
				con.close();
				
				server.ext().revokeAccess(user);
				
				boolean exceptionThrown = false; 
				
				try{
					con = Db4o.openClient(AllTests.SERVER_HOSTNAME, AllTests.SERVER_PORT, user,password);
				}catch(Exception e){
					exceptionThrown = true;
				}finally{
                    
                    // FIXME: openClient should not return anything
                    //        and all ressources should be cleaned up
                    
                    con.close();
                }
				
				Test.ensure(exceptionThrown);
				
				server.close();
				
				
			}catch(Exception e){
				e.printStackTrace();
			}
			
			
			
			
		}
		
	}

}
