/* Copyright (C) 2004 - 2005  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
package com.db4o.test.foundation;

import com.db4o.foundation.Collection4;
import com.db4o.foundation.Iterator4;
import com.db4o.test.Test;

public class Collection4TestCase {
	
	public void testFastIterator() {
		Collection4 c = new Collection4();
		
		String[] expected = new String[] { "1", "2", "3" };		
		c.addAll(expected);
		
		Iterator4 iterator = c.iterator();
		Test.ensure(null != iterator);
		
		for (int i=expected.length-1; i>=0; --i) {
			Test.ensure(iterator.hasNext());
			Test.ensureEquals(expected[i], iterator.next());
		}
		Test.ensure(!iterator.hasNext());
	}
	
	public void testStrictIterator() {
		Collection4 c = new Collection4();
		
		String[] expected = new String[] { "1", "2", "3" };		
		c.addAll(expected);
		
		Iterator4 iterator = c.strictIterator();
		Test.ensure(null != iterator);
		
		for (int i=0; i<expected.length; ++i) {
			Test.ensure(iterator.hasNext());
			Test.ensureEquals(expected[i], iterator.next());
		}
		Test.ensure(!iterator.hasNext());
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Test.run(Collection4TestCase.class);
	}

}
